#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef vector<vector<int>> Matrix;

struct SubProblem{
	int rowCount,colCount;
	Matrix input;
	Matrix diagonal;
	Matrix dp;
	
	SubProblem(Matrix const & in):rowCount(in.size()),colCount(in[0].size()),input(in),diagonal(computeDiagonal()),dp(computeDp()){
		
	}
	
	Matrix computeDiagonal(){
		Matrix result(rowCount,vector<int>(colCount));
		for(int diagonal=0;diagonal<rowCount+colCount-1;diagonal++){
			char lastChar=0;
			int count=0;
			for(int row=0;row<=diagonal;row++){
				auto col=diagonal-row;
				if(row>=rowCount||col>=colCount){
					continue;
				}
				if(input[row][col]==lastChar){
					count++;
				}
				else{
					count=0;
				}
				result[row][col]=count;
				lastChar=input[row][col];
			}
		}
		return result;
	}
	
	Matrix computeDp(){
		Matrix result(rowCount,vector<int>(colCount));
		for(int row=1;row<rowCount;row++){
			for(int col=0;col<colCount;col++){
				if(input[row][col]!=input[row-1][col]){
					continue;
				}
				result[row][col]=min(result[row-1][col]+1,diagonal[row][col]);
			}
		}
		return result;
	}
	
	ll computeResult(){
		ll result =0;
		for(auto row: dp){
			for(auto cell : row){
				result+=cell;
			}
		}
		return result;
	}
};

Matrix rotateMatrix(Matrix const & in){
	Matrix result(in[0].size(),vector<int>(in.size()));
	for(int row=0;row<in[0].size();row++){
		for(int col=0;col<in.size();col++){
			result[row][col]=in[col][(in[0].size()-1)-row];
		}
	}
	return result;
}

int main(){
	int rowCount,colCount;
	cin>>rowCount>>colCount;
	Matrix input(rowCount,vector<int>(colCount));
	for(int i=0;i<rowCount;i++){
		string S;
		cin>>S;
		for(int j=0;j<colCount;j++){
			input[i][j]=S[j];
		}
	}
	
	ll result=0;
	for(int i=0;i<4;i++){
		SubProblem aa(input);
		result+=aa.computeResult();
		input = rotateMatrix(input);
//		for( auto row:aa.dp){
//			for( auto cell:row){
//				cerr<<cell;
//			}
//			cerr<<endl;
//		}
//		cerr<<endl;
	}

	cout<<result<<endl;
	
	
}
